﻿
namespace UltimaCR.Spells.Main
{
    public class ArcherSpells
    {
        private CrossClass.ArcherSpells.Crossclass _crossClass;
        public CrossClass.ArcherSpells.Crossclass CrossClass
        {
            get { return _crossClass ?? (_crossClass = new CrossClass.ArcherSpells.Crossclass()); }
        }

        private PVP.ArcherSpells.Pvp _pvp;
        public PVP.ArcherSpells.Pvp PvP
        {
            get { return _pvp ?? (_pvp = new PVP.ArcherSpells.Pvp()); }
        }

        private Spell _heavyshot;
        public Spell HeavyShot
        {
            get
            {
                return _heavyshot ??
                       (_heavyshot =
                           new Spell
                           {
                               Name = "Heavy Shot",
                               ID = 97,
                               Level = 1,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _straightshot;
        public Spell StraightShot
        {
            get
            {
                return _straightshot ??
                       (_straightshot =
                           new Spell
                           {
                               Name = "Straight Shot",
                               ID = 98,
                               Level = 2,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Debuff,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _ragingstrikes;
        public Spell RagingStrikes
        {
            get
            {
                return _ragingstrikes ??
                       (_ragingstrikes =
                           new Spell
                           {
                               Name = "Raging Strikes",
                               ID = 101,
                               Level = 4,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _venomousbite;
        public Spell VenomousBite
        {
            get
            {
                return _venomousbite ??
                       (_venomousbite =
                           new Spell
                           {
                               Name = "Venomous Bite",
                               ID = 100,
                               Level = 6,
                               GCDType = GCDType.On,
                               SpellType = SpellType.DoT,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _miserysend;
        public Spell MiserysEnd
        {
            get
            {
                return _miserysend ??
                       (_miserysend =
                           new Spell
                           {
                               Name = "Misery's End",
                               ID = 103,
                               Level = 8,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Execute,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _shadowbind;
        public Spell Shadowbind
        {
            get
            {
                return _shadowbind ??
                       (_shadowbind =
                           new Spell
                           {
                               Name = "Shadowbind",
                               ID = 108,
                               Level = 10,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Debuff,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _bloodletter;
        public Spell Bloodletter
        {
            get
            {
                return _bloodletter ??
                       (_bloodletter =
                           new Spell
                           {
                               Name = "Bloodletter",
                               ID = 110,
                               Level = 12,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _repellingshot;
        public Spell RepellingShot
        {
            get
            {
                return _repellingshot ??
                       (_repellingshot =
                           new Spell
                           {
                               Name = "Repelling Shot",
                               ID = 112,
                               Level = 15,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Knockback,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _quicknock;
        public Spell QuickNock
        {
            get
            {
                return _quicknock ??
                       (_quicknock =
                           new Spell
                           {
                               Name = "Quick Nock",
                               ID = 106,
                               Level = 18,
                               GCDType = GCDType.On,
                               SpellType = SpellType.AoE,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _swiftsong;
        public Spell Swiftsong
        {
            get
            {
                return _swiftsong ??
                       (_swiftsong =
                           new Spell
                           {
                               Name = "Swiftsong",
                               ID = 105,
                               Level = 22,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _hawkseye;
        public Spell HawksEye
        {
            get
            {
                return _hawkseye ??
                       (_hawkseye =
                           new Spell
                           {
                               Name = "Hawk's Eye",
                               ID = 99,
                               Level = 26,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _windbite;
        public Spell Windbite
        {
            get
            {
                return _windbite ??
                       (_windbite =
                           new Spell
                           {
                               Name = "Windbite",
                               ID = 113,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.DoT,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _quellingstrikes;
        public Spell QuellingStrikes
        {
            get
            {
                return _quellingstrikes ??
                       (_quellingstrikes =
                           new Spell
                           {
                               Name = "Quelling Strikes",
                               ID = 104,
                               Level = 34,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Defensive,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _barrage;
        public Spell Barrage
        {
            get
            {
                return _barrage ??
                       (_barrage =
                           new Spell
                           {
                               Name = "Barrage",
                               ID = 107,
                               Level = 38,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _bluntarrow;
        public Spell BluntArrow
        {
            get
            {
                return _bluntarrow ??
                       (_bluntarrow =
                           new Spell
                           {
                               Name = "Blunt Arrow",
                               ID = 109,
                               Level = 42,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Interrupt,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _flamingarrow;
        public Spell FlamingArrow
        {
            get
            {
                return _flamingarrow ??
                       (_flamingarrow =
                           new Spell
                           {
                               Name = "Flaming Arrow",
                               ID = 102,
                               Level = 46,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.DoT,
                               CastType = CastType.TargetLocation
                           });
            }
        }
        private Spell _widevolley;
        public Spell WideVolley
        {
            get
            {
                return _widevolley ??
                       (_widevolley =
                           new Spell
                           {
                               Name = "Wide Volley",
                               ID = 111,
                               Level = 50,
                               GCDType = GCDType.On,
                               SpellType = SpellType.AoE,
                               CastType = CastType.Target
                           });
            }
        }
    }
}