﻿
namespace UltimaCR.Spells.Main
{
    public class AstrologianSpells
    {
        private CrossClass.AstrologianSpells.Crossclass _crossClass;
        public CrossClass.AstrologianSpells.Crossclass CrossClass
        {
            get { return _crossClass ?? (_crossClass = new CrossClass.AstrologianSpells.Crossclass()); }
        }

        private PVP.AstrologianSpells.Pvp _pvp;
        public PVP.AstrologianSpells.Pvp PvP
        {
            get { return _pvp ?? (_pvp = new PVP.AstrologianSpells.Pvp()); }
        }

        private Spell _malefic;
        public Spell Malefic
        {
            get
            {
                return _malefic ??
                       (_malefic =
                           new Spell
                           {
                               Name = "Malefic",
                               ID = 3596,
                               Level = 1,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _benefic;
        public Spell Benefic
        {
            get
            {
                return _benefic ??
                       (_benefic =
                           new Spell
                           {
                               Name = "Benefic",
                               ID = 3594,
                               Level = 2,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Heal,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _combust;
        public Spell Combust
        {
            get
            {
                return _combust ??
                       (_combust =
                           new Spell
                           {
                               Name = "Combust",
                               ID = 3599,
                               Level = 4,
                               GCDType = GCDType.On,
                               SpellType = SpellType.DoT,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _lightspeed;
        public Spell Lightspeed
        {
            get
            {
                return _lightspeed ??
                       (_lightspeed =
                           new Spell
                           {
                               Name = "Lightspeed",
                               ID = 3606,
                               Level = 6,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _luminiferousaether;
        public Spell LuminiferousAether
        {
            get
            {
                return _luminiferousaether ??
                       (_luminiferousaether =
                           new Spell
                           {
                               Name = "Luminiferous Aether",
                               ID = 3607,
                               Level = 8,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Defensive,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _helios;
        public Spell Helios
        {
            get
            {
                return _helios ??
                       (_helios =
                           new Spell
                           {
                               Name = "Helios",
                               ID = 3600,
                               Level = 10,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Heal,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _ascend;
        public Spell Ascend
        {
            get
            {
                return _ascend ??
                       (_ascend =
                           new Spell
                           {
                               Name = "Ascend",
                               ID = 3603,
                               Level = 12,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Heal,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _essentialdignity;
        public Spell EssentialDignity
        {
            get
            {
                return _essentialdignity ??
                       (_essentialdignity =
                           new Spell
                           {
                               Name = "Essential Dignity",
                               ID = 3614,
                               Level = 15,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Heal,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _exalteddetriment;
        public Spell ExaltedDetriment
        {
            get
            {
                return _exalteddetriment ??
                       (_exalteddetriment =
                           new Spell
                           {
                               Name = "Exalted Detriment",
                               ID = 3602,
                               Level = 18,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Defensive,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _stella;
        public Spell Stella
        {
            get
            {
                return _stella ??
                       (_stella =
                           new Spell
                           {
                               Name = "Stella",
                               ID = 3597,
                               Level = 22,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Debuff,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _beneficII;
        public Spell BeneficII
        {
            get
            {
                return _beneficII ??
                       (_beneficII =
                           new Spell
                           {
                               Name = "Benefic II",
                               ID = 3610,
                               Level = 26,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Heal,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _draw;
        public Spell Draw
        {
            get
            {
                return _draw ??
                       (_draw =
                           new Spell
                           {
                               Name = "Draw",
                               ID = 3590,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _thebalance;
        public Spell TheBalance
        {
            get
            {
                return _thebalance ??
                       (_thebalance =
                           new Spell
                           {
                               Name = "The Balance",
                               ID = 3590,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Card,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _thebole;
        public Spell TheBole
        {
            get
            {
                return _thebole ??
                       (_thebole =
                           new Spell
                           {
                               Name = "The Bole",
                               ID = 3590,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Card,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _thearrow;
        public Spell TheArrow
        {
            get
            {
                return _thearrow ??
                       (_thearrow =
                           new Spell
                           {
                               Name = "The Arrow",
                               ID = 3590,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Card,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _thespear;
        public Spell TheSpear
        {
            get
            {
                return _thespear ??
                       (_thespear =
                           new Spell
                           {
                               Name = "The Spear",
                               ID = 3590,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Card,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _theewer;
        public Spell TheEwer
        {
            get
            {
                return _theewer ??
                       (_theewer =
                           new Spell
                           {
                               Name = "The Ewer",
                               ID = 3590,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Card,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _thespire;
        public Spell TheSpire
        {
            get
            {
                return _thespire ??
                       (_thespire =
                           new Spell
                           {
                               Name = "The Spire",
                               ID = 3590,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Card,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _diurnalsect;
        public Spell DiurnalSect
        {
            get
            {
                return _diurnalsect ??
                       (_diurnalsect =
                           new Spell
                           {
                               Name = "Diurnal Sect",
                               ID = 3604,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Aura,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _aspectedbenefic;
        public Spell AspectedBenefic
        {
            get
            {
                return _aspectedbenefic ??
                       (_aspectedbenefic =
                           new Spell
                           {
                               Name = "Aspected Benefic",
                               ID = 3595,
                               Level = 34,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Heal,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _royalroad;
        public Spell RoyalRoad
        {
            get
            {
                return _royalroad ??
                       (_royalroad =
                           new Spell
                           {
                               Name = "Royal Road",
                               ID = 3591,
                               Level = 35,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Cooldown,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _disable;
        public Spell Disable
        {
            get
            {
                return _disable ??
                       (_disable =
                           new Spell
                           {
                               Name = "Disable",
                               ID = 3609,
                               Level = 38,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Debuff,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _spread;
        public Spell Spread
        {
            get
            {
                return _spread ??
                       (_spread =
                           new Spell
                           {
                               Name = "Spread",
                               ID = 3592,
                               Level = 40,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _aspectedhelios;
        public Spell AspectedHelios
        {
            get
            {
                return _aspectedhelios ??
                       (_aspectedhelios =
                           new Spell
                           {
                               Name = "Aspected Helios",
                               ID = 3601,
                               Level = 42,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Heal,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _shuffle;
        public Spell Shuffle
        {
            get
            {
                return _shuffle ??
                       (_shuffle =
                           new Spell
                           {
                               Name = "Shuffle",
                               ID = 3593,
                               Level = 45,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _combustII;
        public Spell CombustII
        {
            get
            {
                return _combustII ??
                       (_combustII =
                           new Spell
                           {
                               Name = "Combust II",
                               ID = 3608,
                               Level = 46,
                               GCDType = GCDType.On,
                               SpellType = SpellType.DoT,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _nocturnalsect;
        public Spell NocturnalSect
        {
            get
            {
                return _nocturnalsect ??
                       (_nocturnalsect =
                           new Spell
                           {
                               Name = "Nocturnal Sect",
                               ID = 3605,
                               Level = 50,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Aura,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _synastry;
        public Spell Synastry
        {
            get
            {
                return _synastry ??
                       (_synastry =
                           new Spell
                           {
                               Name = "Synastry",
                               ID = 3612,
                               Level = 50,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _gravity;
        public Spell Gravity
        {
            get
            {
                return _gravity ??
                       (_gravity =
                           new Spell
                           {
                               Name = "Gravity",
                               ID = 3615,
                               Level = 52,
                               GCDType = GCDType.On,
                               SpellType = SpellType.AoE,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _maleficII;
        public Spell MaleficII
        {
            get
            {
                return _maleficII ??
                       (_maleficII =
                           new Spell
                           {
                               Name = "Malefic II",
                               ID = 3598,
                               Level = 54,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _timedilation;
        public Spell TimeDilation
        {
            get
            {
                return _timedilation ??
                       (_timedilation =
                           new Spell
                           {
                               Name = "Time Dilation",
                               ID = 3611,
                               Level = 56,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Defensive,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _collectiveunconscious;
        public Spell CollectiveUnconscious
        {
            get
            {
                return _collectiveunconscious ??
                       (_collectiveunconscious =
                           new Spell
                           {
                               Name = "Collective Unconscious",
                               ID = 3613,
                               Level = 58,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _celestialopposition;
        public Spell CelestialOpposition
        {
            get
            {
                return _celestialopposition ??
                       (_celestialopposition =
                           new Spell
                           {
                               Name = "Celestial Opposition",
                               ID = 3616,
                               Level = 60,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Interrupt,
                               CastType = CastType.Self
                           });
            }
        }
    }
}