﻿
namespace UltimaCR.Spells.Main
{
    public class MonkSpells : PugilistSpells
    {
        private CrossClass.MonkSpells.Crossclass _crossClass;
        public new CrossClass.MonkSpells.Crossclass CrossClass
        {
            get { return _crossClass ?? (_crossClass = new CrossClass.MonkSpells.Crossclass()); }
        }

        private PVP.MonkSpells.Pvp _pvp;
        public new PVP.MonkSpells.Pvp PvP
        {
            get { return _pvp ?? (_pvp = new PVP.MonkSpells.Pvp()); }
        }

        private Spell _rockbreaker;
        public Spell Rockbreaker
        {
            get
            {
                return _rockbreaker ??
                       (_rockbreaker =
                           new Spell
                           {
                               Name = "Rockbreaker",
                               ID = 70,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.AoE,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _shouldertackle;
        public Spell ShoulderTackle
        {
            get
            {
                return _shouldertackle ??
                       (_shouldertackle =
                           new Spell
                           {
                               Name = "Shoulder Tackle",
                               ID = 71,
                               Level = 35,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Movement,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _fistsoffire;
        public Spell FistsOfFire
        {
            get
            {
                return _fistsoffire ??
                       (_fistsoffire =
                           new Spell
                           {
                               Name = "Fists of Fire",
                               ID = 63,
                               Level = 40,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Aura,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _oneilmpunch;
        public Spell OneIlmPunch
        {
            get
            {
                return _oneilmpunch ??
                       (_oneilmpunch =
                           new Spell
                           {
                               Name = "One Ilm Punch",
                               ID = 72,
                               Level = 45,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Debuff,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _dragonkick;
        public Spell DragonKick
        {
            get
            {
                return _dragonkick ??
                       (_dragonkick =
                           new Spell
                           {
                               Name = "Dragon Kick",
                               ID = 74,
                               Level = 50,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Flank,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _formshift;
        public Spell FormShift
        {
            get
            {
                return _formshift ??
                       (_formshift =
                           new Spell
                           {
                               Name = "Form Shift",
                               ID = 4262,
                               Level = 52,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _meditation;
        public Spell Meditation
        {
            get
            {
                return _meditation ??
                       (_meditation =
                           new Spell
                           {
                               Name = "Meditation",
                               ID = 3546,
                               Level = 54,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _theforbiddenchakra;
        public Spell TheForbiddenChakra
        {
            get
            {
                return _theforbiddenchakra ??
                       (_theforbiddenchakra =
                           new Spell
                           {
                               Name = "The Forbidden Chakra",
                               ID = 3546,
                               Level = 54,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Cooldown,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _elixirfield;
        public Spell ElixirField
        {
            get
            {
                return _elixirfield ??
                       (_elixirfield =
                           new Spell
                           {
                               Name = "Elixir Field",
                               ID = 3545,
                               Level = 56,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _purification;
        public Spell Purification
        {
            get
            {
                return _purification ??
                       (_purification =
                           new Spell
                           {
                               Name = "Purification",
                               ID = 3544,
                               Level = 58,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _tornadokick;
        public Spell TornadoKick
        {
            get
            {
                return _tornadokick ??
                       (_tornadokick =
                           new Spell
                           {
                               Name = "Tornado Kick",
                               ID = 3543,
                               Level = 60,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Cooldown,
                               CastType = CastType.Target
                           });
            }
        }
    }
}