﻿
namespace UltimaCR.Spells.Main
{
    public class PugilistSpells
    {
        private CrossClass.PugilistSpells.Crossclass _crossClass;
        public CrossClass.PugilistSpells.Crossclass CrossClass
        {
            get { return _crossClass ?? (_crossClass = new CrossClass.PugilistSpells.Crossclass()); }
        }

        private PVP.PugilistSpells.Pvp _pvp;
        public PVP.PugilistSpells.Pvp PvP
        {
            get { return _pvp ?? (_pvp = new PVP.PugilistSpells.Pvp()); }
        }

        private Spell _bootshine;
        public Spell Bootshine
        {
            get
            {
                return _bootshine ??
                       (_bootshine =
                           new Spell
                           {
                               Name = "Bootshine",
                               ID = 53,
                               Level = 1,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Behind,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _truestrike;
        public Spell TrueStrike
        {
            get
            {
                return _truestrike ??
                       (_truestrike =
                           new Spell
                           {
                               Name = "True Strike",
                               ID = 54,
                               Level = 2,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Behind,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _featherfoot;
        public Spell Featherfoot
        {
            get
            {
                return _featherfoot ??
                       (_featherfoot =
                           new Spell
                           {
                               Name = "Featherfoot",
                               ID = 55,
                               Level = 4,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Defensive,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _snappunch;
        public Spell SnapPunch
        {
            get
            {
                return _snappunch ??
                       (_snappunch =
                           new Spell
                           {
                               Name = "Snap Punch",
                               ID = 56,
                               Level = 6,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Flank,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _secondwind;
        public Spell SecondWind
        {
            get
            {
                return _secondwind ??
                       (_secondwind =
                           new Spell
                           {
                               Name = "Second Wind",
                               ID = 57,
                               Level = 8,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Heal,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _haymaker;
        public Spell Haymaker
        {
            get
            {
                return _haymaker ??
                       (_haymaker =
                           new Spell
                           {
                               Name = "Haymaker",
                               ID = 58,
                               Level = 10,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Debuff,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _internalrelease;
        public Spell InternalRelease
        {
            get
            {
                return _internalrelease ??
                       (_internalrelease =
                           new Spell
                           {
                               Name = "Internal Release",
                               ID = 59,
                               Level = 12,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _touchofdeath;
        public Spell TouchOfDeath
        {
            get
            {
                return _touchofdeath ??
                       (_touchofdeath =
                           new Spell
                           {
                               Name = "Touch of Death",
                               ID = 68,
                               Level = 15,
                               GCDType = GCDType.On,
                               SpellType = SpellType.DoT,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _twinsnakes;
        public Spell TwinSnakes
        {
            get
            {
                return _twinsnakes ??
                       (_twinsnakes =
                           new Spell
                           {
                               Name = "Twin Snakes",
                               ID = 61,
                               Level = 18,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Flank,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _fistsofearth;
        public Spell FistsOfEarth
        {
            get
            {
                return _fistsofearth ??
                       (_fistsofearth =
                           new Spell
                           {
                               Name = "Fists of Earth",
                               ID = 60,
                               Level = 22,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Aura,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _armofthedestroyer;
        public Spell ArmOfTheDestroyer
        {
            get
            {
                return _armofthedestroyer ??
                       (_armofthedestroyer =
                           new Spell
                           {
                               Name = "Arm of the Destroyer",
                               ID = 62,
                               Level = 26,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Interrupt,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _demolish;
        public Spell Demolish
        {
            get
            {
                return _demolish ??
                       (_demolish =
                           new Spell
                           {
                               Name = "Demolish",
                               ID = 66,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.DoT,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _fistsofwind;
        public Spell FistsOfWind
        {
            get
            {
                return _fistsofwind ??
                       (_fistsofwind =
                           new Spell
                           {
                               Name = "Fists of Wind",
                               ID = 73,
                               Level = 34,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Aura,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _steelpeak;
        public Spell SteelPeak
        {
            get
            {
                return _steelpeak ??
                       (_steelpeak =
                           new Spell
                           {
                               Name = "Steel Peak",
                               ID = 64,
                               Level = 38,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Interrupt,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _mantra;
        public Spell Mantra
        {
            get
            {
                return _mantra ??
                       (_mantra =
                           new Spell
                           {
                               Name = "Mantra",
                               ID = 65,
                               Level = 42,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Defensive,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _howlingfist;
        public Spell HowlingFist
        {
            get
            {
                return _howlingfist ??
                       (_howlingfist =
                           new Spell
                           {
                               Name = "Howling Fist",
                               ID = 67,
                               Level = 46,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _perfectbalance;
        public Spell PerfectBalance
        {
            get
            {
                return _perfectbalance ??
                       (_perfectbalance =
                           new Spell
                           {
                               Name = "Perfect Balance",
                               ID = 69,
                               Level = 50,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
    }
}