﻿
namespace UltimaCR.Spells.Main
{
    public class RogueSpells
    {
        private CrossClass.RogueSpells.Crossclass _crossClass;
        public CrossClass.RogueSpells.Crossclass CrossClass
        {
            get { return _crossClass ?? (_crossClass = new CrossClass.RogueSpells.Crossclass()); }
        }

        private PVP.RogueSpells.Pvp _pvp;
        public PVP.RogueSpells.Pvp PvP
        {
            get { return _pvp ?? (_pvp = new PVP.RogueSpells.Pvp()); }
        }

        private Spell _spinningedge;
        public Spell SpinningEdge
        {
            get
            {
                return _spinningedge ??
                       (_spinningedge =
                           new Spell
                           {
                               Name = "Spinning Edge",
                               ID = 2240,
                               Level = 1,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _shadeshift;
        public Spell ShadeShift
        {
            get
            {
                return _shadeshift ??
                       (_shadeshift =
                           new Spell
                           {
                               Name = "Shade Shift",
                               ID = 2241,
                               Level = 2,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Defensive,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _gustslash;
        public Spell GustSlash
        {
            get
            {
                return _gustslash ??
                       (_gustslash =
                           new Spell
                           {
                               Name = "Gust Slash",
                               ID = 2242,
                               Level = 4,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _kissofthewasp;
        public Spell KissOfTheWasp
        {
            get
            {
                return _kissofthewasp ??
                       (_kissofthewasp =
                           new Spell
                           {
                               Name = "Kiss of the Wasp",
                               ID = 2243,
                               Level = 6,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Aura,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _mutilate;
        public Spell Mutilate
        {
            get
            {
                return _mutilate ??
                       (_mutilate =
                           new Spell
                           {
                               Name = "Mutilate",
                               ID = 2244,
                               Level = 8,
                               GCDType = GCDType.On,
                               SpellType = SpellType.DoT,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _hide;
        public Spell Hide
        {
            get
            {
                return _hide ??
                       (_hide =
                           new Spell
                           {
                               Name = "Hide",
                               ID = 2245,
                               Level = 10,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Buff,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _assassinate;
        public Spell Assassinate
        {
            get
            {
                return _assassinate ??
                       (_assassinate =
                           new Spell
                           {
                               Name = "Assassinate",
                               ID = 2246,
                               Level = 12,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Execute,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _throwingdagger;
        public Spell ThrowingDagger
        {
            get
            {
                return _throwingdagger ??
                       (_throwingdagger =
                           new Spell
                           {
                               Name = "Throwing Dagger",
                               ID = 2247,
                               Level = 15,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _mug;
        public Spell Mug
        {
            get
            {
                return _mug ??
                       (_mug =
                           new Spell
                           {
                               Name = "Mug",
                               ID = 2248,
                               Level = 15,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _goad;
        public Spell Goad
        {
            get
            {
                return _goad ??
                       (_goad =
                           new Spell
                           {
                               Name = "Goad",
                               ID = 2249,
                               Level = 18,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Defensive,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _sneakattack;
        public Spell SneakAttack
        {
            get
            {
                return _sneakattack ??
                       (_sneakattack =
                           new Spell
                           {
                               Name = "Sneak Attack",
                               ID = 2250,
                               Level = 22,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _aeolianedge;
        public Spell AeolianEdge
        {
            get
            {
                return _aeolianedge ??
                       (_aeolianedge =
                           new Spell
                           {
                               Name = "Aeolian Edge",
                               ID = 2255,
                               Level = 26,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Damage,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _kissoftheviper;
        public Spell KissOfTheViper
        {
            get
            {
                return _kissoftheviper ??
                       (_kissoftheviper =
                           new Spell
                           {
                               Name = "Kiss of the Viper",
                               ID = 2252,
                               Level = 30,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Aura,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _jugulate;
        public Spell Jugulate
        {
            get
            {
                return _jugulate ??
                       (_jugulate =
                           new Spell
                           {
                               Name = "Jugulate",
                               ID = 2256,
                               Level = 34,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Interrupt,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _dancingedge;
        public Spell DancingEdge
        {
            get
            {
                return _dancingedge ??
                       (_dancingedge =
                           new Spell
                           {
                               Name = "Dancing Edge",
                               ID = 2251,
                               Level = 38,
                               GCDType = GCDType.On,
                               SpellType = SpellType.Debuff,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _deathblossom;
        public Spell DeathBlossom
        {
            get
            {
                return _deathblossom ??
                       (_deathblossom =
                           new Spell
                           {
                               Name = "Death Blossom",
                               ID = 2254,
                               Level = 42,
                               GCDType = GCDType.On,
                               SpellType = SpellType.AoE,
                               CastType = CastType.Self
                           });
            }
        }
        private Spell _shadowfang;
        public Spell ShadowFang
        {
            get
            {
                return _shadowfang ??
                       (_shadowfang =
                           new Spell
                           {
                               Name = "Shadow Fang",
                               ID = 2257,
                               Level = 46,
                               GCDType = GCDType.On,
                               SpellType = SpellType.DoT,
                               CastType = CastType.Target
                           });
            }
        }
        private Spell _trickattack;
        public Spell TrickAttack
        {
            get
            {
                return _trickattack ??
                       (_trickattack =
                           new Spell
                           {
                               Name = "Trick Attack",
                               ID = 2258,
                               Level = 50,
                               GCDType = GCDType.Off,
                               SpellType = SpellType.Behind,
                               CastType = CastType.Target
                           });
            }
        }
    }
}